include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm
.586

mcDefBufLen	= 1024	; len of default buffer for CAT$
mcStringSlots	= 20	; max number of arguments
mcBinSlots	= 10	; for later use with multiple
mcHexSlots	= 10	; BIN$ or HEX$ args
FifRetLen	= 1600	; buffer for FindString

Open_for_input	PROTO:DWORD,:DWORD
GfaInput$	PROTO:DWORD,:DWORD,:DWORD
InstrCi	PROTO:DWORD,:DWORD,:DWORD,:DWORD
FindInFile	PROTO:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

CAT$ MACRO dest:REQ, src:VARARG
LOCAL SrcCt, isaddr, ia, NoDest, LocDest, nu1st, DestInArgs
	DestInArgs = 0
	LocDest textequ <dest>
	pushad
	mov edi, offset mcStrBuffer	;; will hold pointer to received strings
	SrcCt = 0
	NoDest SUBSTR <dest>, 1, 1	;; here the <> are needed
	ifidn NoDest, <">			;; if 1st char = ", we assume this is the first source string
		SrcCt = SrcCt + 1
	elseifidn NoDest, <'>		;; same for apostrophe
		SrcCt = SrcCt + 1
	endif		
	if SrcCt						;; first arg is not the destination
		.data
		  nu1st	db dest, 0		;; write a string arg to .data section
		.code
		  mov eax, offset nu1st	;; load the string into the first slot
		  stosd
		  LocDest equ <0>		;; use default buffer as dest
	endif
	FOR arg, <src>
		LOCAL nustr, quot, tmp$, diaFlag
		SrcCt = SrcCt + 1
		if SrcCt gt mcStringSlots
			echo TOO MANY STRINGS in CAT$:
			tmp$ CATSTR <max allowed: >, %mcStringSlots
			% echo tmp$
			tmp$ CATSTR <dest>,<, >,<src>
			% echo tmp$
			tmp$ CATSTR <Last valid stringarg: >, <arg>
			% echo tmp$
			echo
			Too_many_strings				;; ml.exe will tell you stories
			EXITM <0>
		endif
		diaFlag = 0
		tmp$ equ <arg>
		ia INSTR <arg>, <mcDefBuffer>
		if ia			
			tmp$ equ <0>
		endif
		ifidni <arg>, <addr mcDefBuffer>	; instr
;			echo dia1
			diaFlag = 1
		endif
		ifidni tmp$, <0>
;			echo dia2
			diaFlag = 1
			tmp$ equ <addr mcDefBuffer>
		endif
		ifidni tmp$, <dest>
			diaFlag = 1
;			echo dia3
		endif
		if diaFlag
			DestInArgs = DestInArgs + 1
			if DestInArgs eq 1
				mov eax, len(<tmp$>)
				tmp$ CATSTR <invoke SysAllocStringByteLen, >, tmp$, <, eax>
				tmp$
				mov mcTmp$, eax
			else
;				echo diaCont
				mov eax, mcTmp$
			endif
		else
			if @SizeStr(<arg>) lt 6	;; can't be addr x (min 6 chars)
				isaddr equ <no>
			else
				isaddr SUBSTR <arg>, 1, 4
			endif
			ifidni isaddr, <addr>
				tmp$ SUBSTR <arg>, 6
				ia = opattr(tmp$)
				if ia eq 42	;; global source
					tmp$ CATSTR <mov eax, offset >, tmp$
				else		;; local source
					tmp$ CATSTR <lea eax, >, tmp$
				endif
				tmp$  				;; insert code
			else
				quot SUBSTR <arg>, 1, 1
				tmp$ equ <arg>
				ifidn quot, <">		;; if 1st char = "
					.data
					nustr db arg, 0	;; write arg to .data section
					.code
					tmp$ equ <offset nustr>
				endif
				ifdifi tmp$, <eax>
					mov eax, tmp$	;; avoid a mov eax, eax
				endif
			endif
		endif
		stosd						;; move next string address into mcStrBuffer
          ENDM
	ia SIZESTR LocDest
	if ia lt 6							;; can't be addr x (min 6 chars)
		isaddr equ <no>
	else
		isaddr SUBSTR LocDest, 1, 4
	endif
	ifidni isaddr, <addr>
		tmp$ SUBSTR LocDest, 6	;; fails with <>!
		if opattr(tmp$) eq 42			;; global destination
			tmp$ CATSTR <mov edx, offset >, tmp$
		else						;; local destination
			tmp$ CATSTR <lea edx, >, tmp$
		endif
		tmp$  						;; insert mov edx, offset MyBuffer
	else
		tmp$ CATSTR LocDest, < HasNoAddrIn >, isaddr
		mov edx, LocDest			;; edx=0: use mcDefBuffer, edx=1: continue with mcLastPos$
	endif
	call MulCatCopy
	if DestInArgs
		invoke SysFreeString, mcTmp$
	endif
	popad
	ifidni LocDest, <addr mcDefBuffer>
		EXITM <offset mcDefBuffer>
	elseifidn LocDest, <0>
		EXITM <offset mcDefBuffer>
	else
		EXITM <LocDest>
	endif
ENDM

LOF MACRO fnu:REQ
  fnu2 SUBSTR <fnu>,2,1
  invoke GetFileSize, GfaFH[4*fnu2], 0
  EXITM <eax>
ENDM

FindString MACRO pMain:REQ, Sub$:REQ, sMode:=<0>, sPos:=<1>, inFile$:=<0>, inFileEnd$:=<0>
LOCAL SubEnd$, s1
s1 SIZESTR <inFile$>
  if s1 eq 1
	invoke InstrCi, sPos, pMain, reparg(Sub$), sMode
  else
	if @SizeStr(inFileEnd$) eq 1		;; default: read a line
		SubEnd$ equ addr CrLf_txt
	else
		SubEnd$ equ reparg(inFileEnd$)
	endif
	;; FindInFile proc StartPos:DWORD, Path$:DWORD, Find$:DWORD, FindEnd$:DWORD, Mode:DWORD
	invoke FindInFile, sPos, reparg(inFile$), reparg(Sub$), SubEnd$, sMode
  endif
ENDM

EXIST MACRO fname:REQ, DiscardHandle:=<1>	; .if EXIST("MyFile.*,0) leaves handle
 invoke FindFirstFile, reparg(fname), addr wfd
 .if eax==INVALID_HANDLE_VALUE
	xor eax, eax
 .elseif DiscardHandle
	invoke FindClose, eax
 .endif
 EXITM <eax>
ENDM

MsgBox MACRO text:REQ, title:REQ, style:REQ
  invoke MessageBox, MDLG, reparg(text), reparg(title), style
ENDM

INPUT MACRO fnu:REQ, tostr:REQ, nBytes:REQ
 fnu2 SUBSTR <fnu>,2,1
 invoke GfaInput$, fnu2, tostr, nBytes
ENDM

OPEN MACRO mc:REQ, fnu:REQ, fname:REQ
 fnu2 SUBSTR <fnu>,2,1
 IFIDN <mc>,<"I">
	invoke Open_for_input, fnu2, reparg(fname)
 ELSE
	invoke Open_for_output, fnu2, reparg(fname), mc
 ENDIF
ENDM

EXIST MACRO fname:REQ, DiscardHandle:=<1>	; .if EXIST("MyFile.*,0) leaves handle
 invoke FindFirstFile, reparg(fname), addr wfd
 .if eax==INVALID_HANDLE_VALUE
	xor eax, eax
 .elseif DiscardHandle
	invoke FindClose, eax
 .endif
 EXITM <eax>
ENDM

File EQU GfaHash 
GfaHash MACRO fnu:REQ
  EXITM <GfaFH[4*fnu]>
ENDM

CLOSE MACRO fnu:=<10>	;; 0-9 allowed, 10 means close all
  mov eax, fnu
  call GfaClose
ENDM

.data?
TitleBuffer	dd 100 dup(?)
MsgBuffer	dd 100 dup(?)
MDLG	dd ?
mcStrCounter	dd ?	; CAT$: number of src arguments
mcBinCounter	dd ?	; number of BIN$s
mcHexCounter	dd ?	; number of HEX$s
mcLastPos$	dd ?	; pointer to last position for append, use with CAT$(1, ...)
mcTmp$	dd ?	; needed if destination is among the sources
mcString$	dd ?	; returned by CAT$
mcStrBuffer	dd mcStringSlots dup (?)	; holds pointers to CAT$ args
mcBinBuffer	dd mcBinSlots*36/4 dup (?)	; holds contents of BIN$s
mcHexBuffer	dd mcHexSlots*10/4 dup (?)	; holds contents of HEX$s
mcDefBuffer	dd mcDefBufLen/4 dup (?)	; default buffer if first arg=0
FileBuf$	dd ?			; Pointer
FifRetBuf	dd FifRetLen/4 dup (?)	; Buffer for FindString
LastPathBuf	dd MAX_PATH/4 dup (?)	; remember last file name
GfaFH	dd 10 dup(?)	; Gfa file handles, 0-9
CurPos	dd ?
wfd	WIN32_FIND_DATA <?>

.data
FifRet$	dd FifRetBuf
LastPath$	dd LastPathBuf
CrLf$	dd CrLf_txt	; pointer to 0D0A
CrLf_txt	db 13, 10, 0
Title$	dd TitleBuffer
AppName	db "FindInFile:" ,0

.code

align 4
MulCatCopy proc				; used by CAT$ (with a pushad)
  mcMagic = 01010101h
  xor eax, eax
  stosd							; mark end of args
  .if edx==0
	mov edx, offset mcDefBuffer	; edx=0, safe copy: take default 
	mov edi, mcDefBufLen		; buffer len, e.g. 1024, then add
	add edi, edx				; current pos and check below
  .else
	.if edx==1
		mov edx, mcLastPos$
	.endif
	mov edi, edx
	add edi, 0FFFFFFFh			; only edx==0 is safe ^ ^
  .endif
  mov esi, offset mcStrBuffer
  push edx	; will return a pointer to string start at end of proc

; ---------- put the pointer to the next string argument into eax: ----------
mcNext:
  lodsd	; mov eax, lpsrc, mov edx, lpdest
  or eax, eax
  jz mcDone

align 4	; TEST B ----------------------------------------
@@:
  mov ebx, [eax]			; get next 4 bytes
  ; mov ecx, ebx			; 21% slower than lea on P4,
  ; sub ecx, mcMagic		; tested with rep 800
  lea ecx, [ebx-mcMagic]	; subtract 1 from each byte
  test ecx, 80808080h		; same as and ecx, 80808080h
  jnz @F					; jump if zero byte

WasNotZero:
  cmp edi, edx				; safe copy...
  jle mcDone
  mov [edx], ebx			; store a dword
  add eax, 4				; eax, edx 1% faster than edx, eax on P4
  add edx, 4				; inc destination
  jmp @B

@@:	not ebx					; invert all bytes - for the full story, see
	and ecx, ebx			; http://www.masm32.com/board/index.php?topic=1589.msg12333#msg12333 
	not ebx					; and each byte with inversion, then restore bytes
	test ecx, 80808080h		; bytes=80h for null, otherwise 0
	jz WasNotZero

align 4					; align 16 is somewhat slower
@@:
  mov cl, [eax]				; copy non-aligned bytes
  mov [edx], cl
  add eax, 1				; add is 16% faster then inc on P4
  add edx, 1
  test cl, cl
  jnz @B
  dec edx
  jmp mcNext

mcDone:
  mov mcLastPos$, edx	; save pointer to END of string, for use with CAT$(1, ...
  pop mcString$			; pushed as edx, return pointer to START of string
  ret
MulCatCopy endp
pend2b:

FindInFile proc StartPos:DWORD, Path$:DWORD, Find$:DWORD, FindEnd$:DWORD, Mode:DWORD
LOCAL fLen:DWORD, FeCrLf$:DWORD
  invoke lstrcmp, Path$, LastPath$
  ; MsgBox Path$, "The Path:", MB_OK
  .if eax
	invoke lstrcpy, LastPath$, Path$
	.if EXIST(Path$)
		free$ FileBuf$
		OPEN "I", #1, Path$
		mov fLen, LOF(#1)
		mov FileBuf$, alloc$(fLen)
		INPUT #1, FileBuf$, fLen
		CLOSE
	.else
		MsgBox Path$, "Sorry, this file does not exist:", MB_OK
		ret
	.endif
  .endif
  invoke InstrCi, StartPos, FileBuf$, Find$, Mode
  .if eax
	push ecx
	push eax
	mov edx, FindEnd$
	invoke InstrCi, 0, FileBuf$, edx, Mode	; continue search
	pop edx
	push esi
	mov esi, eax
	add esi, len(FindEnd$)
	sub esi, edx		; endpos - startpos = ct
	inc esi
	push esi
	invoke lstrcpyn, FifRet$, edx, esi	; copy esi bytes
	pop eax	
	pop esi
	dec eax				; eax=len of found line
	mov edx, FifRet$	; edx=pointer to buffer containing the found line
	; int 3
	pop ecx				; ecx=pos in file
  .endif
  ret
FindInFile endp

align 4	; -> FindString macro 
InstrCi proc uses edi esi ebx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
  mov eax, lpSource		; e.g. invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 0 means
  mov ecx, StartPos		; start at pos1, find Substr in Mainstr, case-sensitive
  .if ecx
	dec ecx				; 1-based index, so if 1 is passed, please add nothing to eax
  .else
	mov ecx, CurPos	; invoke InstrCi, 0, ... means continue with Current Position
  .endif
  add eax, ecx				; start with current position or StartPos
  xor ebx, ebx				; default mode: case-sensitive search
  .if sMode
	add ebx, 20h		; intellicase: finds "test" and "Test" but not "TEST" in "This is a Test"
	.if sMode==1		; lowercase bit mask for finding "TEST" in "This is a Test"
		mov ebx, 20202020h
	.endif
  .endif

NoSucc:
  mov edx, lpPattern	; address of pattern
;  .if edx==0
;	pushad
;	MsgBox STR$(eax), chr$("Gotcha"), MB_OKCANCEL
;	.if eax==IDCANCEL
;		exit
;	.endif
	; int 3
;	popad
;	.data
;		MyPat	db 13, 10, 0
;	.code
;	mov edx, offset MyPat
;	mov lpPattern, edx
;  .endif
  mov edx, [edx]		; edx has 4 bytes of pattern, e.g. test
  or edx, ebx			; make first byte or first 4 bytes of pattern lowercase, if sMode is set

@@:
	REPEAT 3
	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; these 3 are innermost loops, and inc eax would cost 2-3%
	cmp cx, dx		; compare 2 bytes of source with pattern
	je @F
	ENDM

	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; this is the last innermost loop, and inc eax would cost 2-3%
	cmp cx, dx		; compare 2 bytes of source with pattern
	jne @B

@@:	mov esi, lpPattern
	mov edi, eax	; current pos in source string
	inc esi			; inc changes flags
	push eax		; save current pos

@@:	mov al, [esi]	; movzx eax, byte ptr [esi]
	inc esi			; add esi, 1 is faster but here it doesn't matter
	test al, al		; pattern end?
	jz @F
	or al, bh		; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	mov cl, [edi]
	or cl, bh			; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	inc edi			; add edi, 1 is faster but here it doesn't matter
	cmp al, cl		; if equal, go for the next char
	je @B

@@:	pop eax		; current pos in source string restored

	mov ecx, [esi-1]	; check for end of pattern - if yes, we are done
	or cl, cl			; get the flag
	jz @F			; if not zero, we still have to test a...
	mov ecx, [esi-2]		; ... rare case: pattern and source finish on the same byte
	or cl, cl
	jnz NoSucc

@@:	mov ecx, eax		; SUCCESS!
	sub ecx, lpSource	; ecx has the relative pos, if needed
	mov CurPos, ecx	
	dec eax				; we return in eax the pos in lpSource where the pattern was found
	jmp @F

SrcEnd:
	xor eax, eax		; no match found, sorry
@@:
	ret
InstrCi endp

GfaInput$ proc HashF:DWORD, tgt:DWORD, bytes:DWORD
LOCAL locBytes:DWORD
  mov ecx, HashF
  lea ecx, [GfaFH+4*ecx]
  invoke ReadFile, [ecx], tgt, bytes, addr locBytes, 0
  ret
GfaInput$ endp

GfaClose proc
LOCAL ct:DWORD
  push esi
  .if eax==10				; 10=no argument
	mov ct, eax
	.While ct
		dec ct
		mov eax, ct		; 9 to 0
		call GfaCloseN
	.Endw
  .else
	call GfaCloseN
  .endif
  pop esi
  ret
GfaClose endp

GfaCloseN proc	; check if open, if yes close
  lea esi, [GfaFH+4*eax]
  mov eax, [esi]
  .if eax
	invoke CloseHandle, eax
	xor eax, eax
	mov [esi], eax	; clear the handle
  .endif
  ret
GfaCloseN endp

Open_for_input proc HashF:DWORD, OpenF$:DWORD
  mov eax, HashF
  lea ecx, [GfaFH+4*eax]
  push ecx
  invoke CreateFile, OpenF$, GENERIC_READ, FILE_SHARE_READ,
  NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
  pop ecx
  mov [ecx], eax
  .if eax==INVALID_HANDLE_VALUE
	MsgBox OpenF$, "File not found:", MB_OK
	exit
  .endif
  ret
Open_for_input endp
